/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IEST                                                     */
/* Tabela : INSCRESTAD                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_IEST'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_IEST
GO

CREATE TRIGGER DTULTATU_IEST
ON INSCRESTAD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'INSCRESTAD', null, 'CDEMPRESA=' + CDEMPRESA + ';' +
                                     'CDINSCESTA='+ CDINSCESTA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE INSCRESTAD
      SET DTULTATUIEST = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(INSCRESTAD.CDINSCESTA,0)    = ISNULL(INSERTED.CDINSCESTA,0))     AND
            (ISNULL(INSCRESTAD.NMREPRINSEST,0)    = ISNULL(INSERTED.NMREPRINSEST,0))     AND
            (ISNULL(INSCRESTAD.IDTPIJURIEST,0)= ISNULL(INSERTED.IDTPIJURIEST,0)) AND
            (ISNULL(INSCRESTAD.NRINSJURIEST,0)    = ISNULL(INSERTED.NRINSJURIEST,0))     AND
            (ISNULL(INSCRESTAD.SGESTADO,0)  = ISNULL(INSERTED.SGESTADO,0))   AND
            (ISNULL(INSCRESTAD.NRCEPIEST,0)   = ISNULL(INSERTED.NRCEPIEST,0))    AND
            (ISNULL(INSCRESTAD.DSENDEIEST,0)  = ISNULL(INSERTED.DSENDEIEST,0))   AND
            (ISNULL(INSCRESTAD.NMBAIRIEST,0)  = ISNULL(INSERTED.NMBAIRIEST,0))   AND
            (ISNULL(INSCRESTAD.NRTELEIEST,0)    = ISNULL(INSERTED.NRTELEIEST,0))     AND
            (ISNULL(INSCRESTAD.NRFAXIEST,0)= ISNULL(INSERTED.NRFAXIEST,0)) AND
            (ISNULL(INSCRESTAD.CDPAIS,0) = ISNULL(INSERTED.CDPAIS,0))  AND
            (ISNULL(INSCRESTAD.CDMUNICIPIO,0)     = ISNULL(INSERTED.CDMUNICIPIO,0))      AND
            (ISNULL(INSCRESTAD.CDEMPRESA,0)= ISNULL(INSERTED.CDEMPRESA,0)) AND
            (ISNULL(INSCRESTAD.IDTPAMBIENTENFE, 0) = ISNULL(INSERTED.IDTPAMBIENTENFE, 0)) OR
            (ISNULL(INSCRESTAD.NRSERIECERTIFIC, 0) = ISNULL(INSERTED.NRSERIECERTIFIC, 0)) OR
            (INSCRESTAD.DTINIVIGIEST) <> (INSERTED.DTINIVIGIEST) OR
            (INSCRESTAD.DTFIMVIGIEST) <> (INSERTED.DTFIMVIGIEST);
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_IEST','5.05.012';
GO

