package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class AprovacaoCardapioPelaUnidadePage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Aprovação do Cardápio pela Unidade']");
    By agrupamentoUnidade = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By limpaAgrupamento = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border close-x']");
    By filtroBusca = By.xpath("//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaBusca = By.xpath("//*[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaBusca = By.xpath("//div[@class = 'tr cell1']");
    By checkBoxTodasUnidades = By.xpath("//label[@for = 'zh-checkbox-checkboxUnidade']//span[@zh-icon='checked no-border']");
    By campoUnidade = By.xpath("//div[@id= 'CDFILIAL']");
    By selecionaUnidade = By.xpath("//div[@class = 'header-content']//div[@data-zh-field-name='__CHECKBOX']");
    By btnOk = By.xpath("//*[@id='footer']//span[text() = 'Ok']");
    By checkBoxTodosServicos = By.xpath("//label[@for = 'zh-checkbox-checkboxServico']//span[@zh-icon='checked no-border']");
    By campoServico = By.xpath("//div[@id = 'CDSERVICO']");
    By selecionaServico = By.xpath("//div[@class = 'header-content']//div[@data-zh-field-name='__CHECKBOX']");
    By dataCardapio = By.xpath("//div[@id = 'dataCardapio']");
    By clicaMesCardapio = By.xpath("//div[@class = 'month']//div[text() = 'Abr']");
    By limpaTipoCusto = By.xpath("//div[@id = 'NMTIPOCUSTO']//span[@zh-icon='no-border close-x']");
    By buscaTipoCusto = By.xpath("//div[@id = 'NMTIPOCUSTO']//span[@zh-icon='no-border search']");
    By custoAprovacao = By.xpath("//section[@class = 'popup-container']//span[text() = 'Custo Médio Bruto Atual']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By servicoAlmoco = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'ALMOÇO ESPECIAL']");
    By servicoJantar = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'JANTAR']");
    By observacaoFilial = By.xpath("//input[@id = 'DSOBSAPROCARDFILI']");
    By observacaoGeral = By.xpath("//textarea[@id = 'DSGERAPROCARDFILI']");
    By ckeckBoxCopiaInformacaoGeral = By.xpath("//label[@for= 'zh-checkbox-COPIAR_OBS_GERAL']//div[@class= 'zh-box mousetrap zh-ripple-effect']");
    By todosServicosAprovacao = By.xpath("//div[@class = 'header-content']//div[@data-zh-field-name='__CHECKBOX']");
    By servicoAprovacao = By.xpath("//div[@class = 'tr cell1']//div[@data-zh-field-name='__CHECKBOX']");
    By btnAprovar = By.xpath("//li[@data-zh-id='66514898316107324241474']");
    By btnCancelar = By.xpath("//li[@data-zh-id='6651489834398426001476']");
    By btnCancela = By.xpath("//li[@data-zh-id='66514898327882120621452']");
    By btnConfirmaAprovacaoDesaprovacao = By.xpath("//button[@data-ng-repeat='button in buttons']//span[text() = 'Sim']");
    By btnOkAprovacao = By.xpath("//button[@data-ng-repeat='button in buttons']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");

    public void acessaTela(){
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Aprovação do Cardápio pela Unidade");
        tempo();
        click(selecionaTela);
        tempo();
    }

    public void realizaFiltro(){
    click(agrupamentoUnidade);
    tempo();
    click(filtroBusca);
    click(filtroBusca);
    click(filtroBusca);
    tempo();
    click(informaBusca);
    tempo();
    clearAndSendKeys(informaBusca,"0000000002");
    tempo();
    click(selecionaBusca);
    click(checkBoxTodasUnidades);
    click(campoUnidade);
    tempo();
    click(filtroBusca);
    click(filtroBusca);
    click(informaBusca);
    clearAndSendKeys(informaBusca,"0002");
    tempo();
    click(selecionaUnidade);
    click(btnOk);
    tempo();
    click(checkBoxTodosServicos);
    click(campoServico);
    click(selecionaServico);
    click(btnOk);
    tempo();
    click(dataCardapio);
    tempo();
    click(clicaMesCardapio);
    tempo();
    click(btnConfirmar);
    tempo();

    }

    public void realizaAprovacao(){
        click(servicoAlmoco);
        tempo();
        click(observacaoFilial);
        clearAndSendKeys(observacaoFilial,"Aprovação de Cardápio Almoço");
        tempo();
        click(observacaoGeral);
        clearAndSendKeys(observacaoGeral,"Observação Geral Cardápio!");
        tempo();
        click(btnConfirmar);
        tempo();
        click(servicoJantar);
        tempo();
        click(observacaoFilial);
        clearAndSendKeys(observacaoFilial,"Aprovação de Cardápio Jantar");
        click(btnConfirmar);
        tempo();
        click(servicoAprovacao);
        tempo();
        click(btnAprovar);
        tempo();
        click(btnConfirmaAprovacaoDesaprovacao);
        tempo();
        click(btnOkAprovacao);
        tempo();
    }

    public void cancelaAprovacao(){
        click(servicoAprovacao);
        tempo();
        click(btnCancelar);
        tempo();
        click(btnConfirmaAprovacaoDesaprovacao);
        tempo();
        click(btnOkAprovacao);
        tempo();
    }

    public void aprovaTodosServicos(){
        click(btnVoltar);
        tempo();
        click(limpaAgrupamento);
        tempo();
        click(limpaTipoCusto);
        click(buscaTipoCusto);
        tempo();
        click(filtroBusca);
        click(filtroBusca);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"Custo Médio Bruto Atual");
        tempo();
        click(custoAprovacao);
        click(btnConfirmar);
        tempo();
        click(servicoAlmoco);
        tempo();
        click(observacaoFilial);
        clearAndSendKeys(observacaoFilial,"Almoço Aprovado");
        tempo();
        click(observacaoGeral);
        clearAndSendKeys(observacaoGeral,"Observação Geral Cardápio!");
        tempo();
        click(btnConfirmar);
        tempo();
        click(servicoJantar);
        tempo();
        click(observacaoFilial);
        clearAndSendKeys(observacaoFilial,"Jantar Aprovado");
        click(btnConfirmar);
        tempo();
        click(todosServicosAprovacao);
        tempo();
        click(btnConfirmaAprovacaoDesaprovacao);
        tempo();
        click(btnAprovar);
        tempo();
        click(btnConfirmaAprovacaoDesaprovacao);
        tempo();
        click(btnOkAprovacao);
        tempo();
        click(servicoAlmoco);
        tempo();
        click(btnCancela);
        tempo();
        click(servicoJantar);
        tempo();
        click(ckeckBoxCopiaInformacaoGeral);
        tempo();
        click(btnConfirmar);
        tempo();
    }

    public void limpaTextos(){
        click(servicoAlmoco);
        tempo();
        click(observacaoFilial);
        clear(observacaoFilial);
        tempo();
        click(observacaoGeral);
        clear(observacaoGeral);
        tempo();
        click(btnConfirmar);
        tempo();
        click(servicoJantar);
        tempo();
        click(observacaoFilial);
        tempo();
        clear(observacaoFilial);
        tempo();
        click(observacaoGeral);
        tempo();
        clear(observacaoGeral);
        tempo();
        click(ckeckBoxCopiaInformacaoGeral);
        tempo();
        click(btnConfirmar);
        tempo();
        click(btnVoltar);
        tempo();
    }

    public void cancelaTodos(){
        click(todosServicosAprovacao);
        tempo();
        click(btnConfirmaAprovacaoDesaprovacao);
        tempo();
        click(btnCancelar);
        tempo();
        click(btnConfirmaAprovacaoDesaprovacao);
        tempo();
        click(btnOkAprovacao);
        tempo();
    }


}
