package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PratoXPorcionamentoFlows;
import com.javaseleniumtemplate.pages.PratoXPorcionamentoPage;
import org.testng.annotations.Test;

public class PratoXPorcionamentoTests extends TestBase {

    PratoXPorcionamentoPage pratoXPorcionamentoPage;
    PratoXPorcionamentoFlows pratoXPorcionamentoFlows;
    LoginFlows loginFlows;

    //selecionar dois pratos diferentes no campo prato, do formulário de adicionar prato x porcionamento
    //verificar os dados do primeiro prato e também o porcionamento do mesmo que foi adicionado no início do teste
    //editar a quantidade do porcionamento
    //adicionar um segundo porcionamento ao mesmo prato e verificar a quantidade do mesmo
    //excluir os 2 porcionamentos do mesmo prato
    //verificar os dados e o porcionamento do segundo prato que foi adicionado no início do teste
    //excluir o porcionamento do segundo prato
    @Test
    public void pratoXPorcionamento() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.adicionarRegistro();
        pratoXPorcionamentoPage.verificarPorcionamento();
        pratoXPorcionamentoPage.editarQuantidadePorcionamento();
        pratoXPorcionamentoPage.addSegundoPorcAoMesmoPrato();
        pratoXPorcionamentoPage.excluirPorcionamentos(2);
        pratoXPorcionamentoPage.verificarSegunPratoFeijoadaMagra();
        pratoXPorcionamentoPage.verificarPorcionamento();
        pratoXPorcionamentoPage.excluirPorcionamentos(1);

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    //adicionar dois pratos no primeiro registro
    //na sequência adicionar novamente um dos pratos com o mesmo porcionamento
    //dessa forma deve ser emitida uma mensagem perguntando se o valor deve ser sobreposto
    //adicionar o mesmo prato, porém dessa vez com um porcionamento diferente
    //dessa forma deve ser adicionado sem nenhuma restrição
    //acessar o primeiro prato e tentar adicionar ao mesmo um porcionamento já cadastrado. Não deve ser permitido
    //excluir o porcionamento e os pratos adicionados
    @Test
    public void tentarAddMesmoPratoDuasVezes() {
        pratoXPorcionamentoPage = new PratoXPorcionamentoPage();
        pratoXPorcionamentoFlows = new PratoXPorcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pratoXPorcionamentoFlows.navegatePratoXPorcionamento();
        pratoXPorcionamentoPage.adicionarRegistro();
        pratoXPorcionamentoPage.addPratoFeijoadaSimples();
        pratoXPorcionamentoPage.addPratoFeijoadaSimplesPorcDiferente();
        pratoXPorcionamentoPage.tentarAddMesmoPorcionamentoAoMesmoPrato();
        pratoXPorcionamentoPage.excluirPorcionamentos(2);
        pratoXPorcionamentoPage.verificarPorcionamento();
        pratoXPorcionamentoPage.excluirPorcionamentos(1);

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}
